commit 81ffb19017daf7197445ed0793e925674a3970d5
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Wed Dec 8 21:14:19 2021

    Fortran: avoid NULL pointer dereference on missing or bad dummy arguments
    
    gcc/fortran/ChangeLog:
    
            PR fortran/103609
            * symbol.c (gfc_sym_get_dummy_args): Catch NULL pointer
            dereference.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/103609
            * gfortran.dg/pr103609.f90: New test.
    
    (cherry picked from commit b77968a70537429b4f548f90c369d26e6b6943cc)

diff --git a/gcc/fortran/symbol.c b/gcc/fortran/symbol.c
index 6d61bf4982b..c2dad08d878 100644
--- a/gcc/fortran/symbol.c
+++ b/gcc/fortran/symbol.c
@@ -5253,6 +5253,9 @@ gfc_sym_get_dummy_args (gfc_symbol *sym)
 {
   gfc_formal_arglist *dummies;
 
+  if (sym == NULL)
+    return NULL;
+
   dummies = sym->formal;
   if (dummies == NULL && sym->ts.interface != NULL)
     dummies = sym->ts.interface->formal;
diff --git a/gcc/testsuite/gfortran.dg/pr103609.f90 b/gcc/testsuite/gfortran.dg/pr103609.f90
new file mode 100644
index 00000000000..57f6a3b1531
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr103609.f90
@@ -0,0 +1,15 @@
+! { dg-do compile }
+! PR fortran/103609 - ICE in gfc_sym_get_dummy_args
+! Contributed by G.Steinmetz
+
+program p
+  implicit none
+  integer :: i
+  do i = 1, 2
+     call s
+  end do
+contains
+  subroutine s
+    call sub(x) ! { dg-error "has no IMPLICIT type" }
+  end
+end

